// Linear Congruential Generator
#ifndef LCG_H
#define LCG_H

#ifndef RNG_H
#include "rng.h"
#endif

class LCG : public RNG
{
private:
    static long quotient /* = LONG_MAX / 16807L */ ;
    static long reminder /* = LONG_MAX % 16807L */ ;
    long seed_val;

	static RNGInfo *info;
public:
// we must override these two pure virtual functions ...
    void Seed (uint32);
    uint32 lRand ();

// we override these two ...
	double dRand();
	const RNGInfo *Info() { return info; };

// we will have a constructor too
    LCG (uint32);
} ;

#endif
